Index: trunk/kBuild/sdks/WINDDK71.kmk
===================================================================
--- trunk/kBuild/sdks/WINDDK71.kmk	(revision 2602)
+++ trunk/kBuild/sdks/WINDDK71.kmk	(revision 2602)
@@ -0,0 +1,107 @@
+# $Id$
+## @file
+# kBuild SDK - The Microsoft Windows 7 DDK, v7.1.
+#              Defaults to $(KBUILD_TARGET_ARCH). Base SDK.
+#
+
+#
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+SDK_WINDDK71 := The Microsoft Windows 7 DDK, v7.1. \
+                Defaults to $(KBUILD_TARGET_ARCH). Base SDK.
+
+# SDK Specific Properties
+ifndef PATH_SDK_WINDDK71
+ PATH_SDK_WINDDK71 := $(wildcard $(PATH_DEVTOOLS_TRG)/ddk/7600.16385.1*)
+ ifeq ($(PATH_SDK_WINDDK71),)
+  PATH_SDK_WINDDK71 := $(wildcard $(PATH_DEVTOOLS)/win.x86/ddk/7600.16385.1*)
+ endif
+ ifeq ($(PATH_SDK_WINDDK71),)
+  PATH_SDK_WINDDK71 := $(wildcard $(PATH_DEVTOOLS)/win.amd64/ddk/7600.16385.1*)
+ endif
+ ifeq ($(PATH_SDK_WINDDK71),)
+  ifeq ($(KBUILD_HOST),win)
+   PATH_SDK_WINDDK71 := $(wildcard C:/WinDDK/7600.16385.1*)
+  endif
+ endif
+ ifneq ($(PATH_SDK_WINDDK71),)
+  PATH_SDK_WINDDK71 := $(lastword $(sort $(PATH_SDK_WINDDK71)))
+ else
+  $(warning kBuild: PATH_SDK_WINDDK71 couldn't be determined!)
+  PATH_SDK_WINDDK71 := $(PATH_DEVTOOLS)/win.x86/ddk/7600.16385.1-not-found
+ endif
+else
+ # Resolve any fancy stuff once and for all.
+ PATH_SDK_WINDDK71 := $(PATH_SDK_WINDDK71)
+endif
+
+PATH_SDK_WINDDK71_INC     ?= $(PATH_SDK_WINDDK71)/inc
+PATH_SDK_WINDDK71_INC_API ?= $(PATH_SDK_WINDDK71_INC)/api
+PATH_SDK_WINDDK71_INC_CRT ?= $(PATH_SDK_WINDDK71_INC)/crt
+PATH_SDK_WINDDK71_INC_DDK ?= $(PATH_SDK_WINDDK71_INC)/ddk
+
+PATH_SDK_WINDDK71_LIB_ROOT      ?= $(PATH_SDK_WINDDK71)/lib
+PATH_SDK_WINDDK71_LIB_WLH_ROOT  ?= $(PATH_SDK_WINDDK71_LIB_ROOT)/wlh
+PATH_SDK_WINDDK71_LIB_WNET_ROOT ?= $(PATH_SDK_WINDDK71_LIB_ROOT)/wnet
+PATH_SDK_WINDDK71_LIB_WXP_ROOT  ?= $(PATH_SDK_WINDDK71_LIB_ROOT)/wxp
+PATH_SDK_WINDDK71_LIB_W2K_ROOT  ?= $(PATH_SDK_WINDDK71_LIB_ROOT)/w2k
+PATH_SDK_WINDDK71_LIB_WDF_ROOT  ?= $(PATH_SDK_WINDDK71_LIB_ROOT)/w2k
+
+PATH_SDK_WINDDK71_LIB_WLH.amd64 ?= $(PATH_SDK_WINDDK71_LIB_WLH_ROOT)/amd64
+PATH_SDK_WINDDK71_LIB_WLH.ia64  ?= $(PATH_SDK_WINDDK71_LIB_WLH_ROOT)/ia64
+PATH_SDK_WINDDK71_LIB_WLH.x86   ?= $(PATH_SDK_WINDDK71_LIB_WLH_ROOT)/i386
+PATH_SDK_WINDDK71_LIB_WLH       ?= $(PATH_SDK_WINDDK71_LIB_WLH.$(KBUILD_TARGET_ARCH))
+
+PATH_SDK_WINDDK71_LIB_WNET.amd64?= $(PATH_SDK_WINDDK71_LIB_WNET_ROOT)/amd64
+PATH_SDK_WINDDK71_LIB_WNET.ia64 ?= $(PATH_SDK_WINDDK71_LIB_WNET_ROOT)/ia64
+PATH_SDK_WINDDK71_LIB_WNET.x86  ?= $(PATH_SDK_WINDDK71_LIB_WNET_ROOT)/i386
+PATH_SDK_WINDDK71_LIB_WNET      ?= $(PATH_SDK_WINDDK71_LIB_WNET.$(KBUILD_TARGET_ARCH))
+
+PATH_SDK_WINDDK71_LIB_WXP.x86   ?= $(PATH_SDK_WINDDK71_LIB_WXP_ROOT)/i386
+PATH_SDK_WINDDK71_LIB_WXP       ?= $(PATH_SDK_WINDDK71_LIB_WXP.$(KBUILD_TARGET_ARCH))
+
+PATH_SDK_WINDDK71_LIB_W2K.x86   ?= $(PATH_SDK_WINDDK71_LIB_W2K_ROOT)/i386
+PATH_SDK_WINDDK71_LIB_W2K       ?= $(PATH_SDK_WINDDK71_LIB_W2K.$(KBUILD_TARGET_ARCH))
+
+PATH_SDK_WINDDK71_LIB.amd64     ?= $(PATH_SDK_WINDDK71_LIB_WLH.amd64)
+PATH_SDK_WINDDK71_LIB.ia64      ?= $(PATH_SDK_WINDDK71_LIB_WLH.ia64)
+PATH_SDK_WINDDK71_LIB.x86       ?= $(PATH_SDK_WINDDK71_LIB_WLH.x86)
+PATH_SDK_WINDDK71_LIB           ?= $(PATH_SDK_WINDDK71_LIB.$(KBUILD_TARGET_ARCH))
+
+# General Properties used by kBuild
+SDK_WINDDK71_DEFS.amd64    ?= _AMD64_ AMD64 _WIN64
+SDK_WINDDK71_DEFS.ia64     ?= _IA64_=1 IA64=1 _WIN64 _MSC_EXTENSIONS
+SDK_WINDDK71_DEFS.x86      ?= _X86_=1 i386=1 STD_CALL
+SDK_WINDDK71_INCS          ?= \
+	$(PATH_SDK_WINDDK71_INC_API) \
+	$(PATH_SDK_WINDDK71_INC_DDK)
+# The compiler tool(s) will have to select the appropriate crt includes.
+SDK_WINDDK71_LIBPATH.amd64 ?= $(PATH_SDK_WINDDK71_LIB_WLH.amd64)
+SDK_WINDDK71_LIBPATH.ia64  ?= $(PATH_SDK_WINDDK71_LIB_WLH.ia64)
+SDK_WINDDK71_LIBPATH.x86   ?= $(PATH_SDK_WINDDK71_LIB_WLH.x86)
+
Index: trunk/kBuild/sdks/WINDDK71WLH.kmk
===================================================================
--- trunk/kBuild/sdks/WINDDK71WLH.kmk	(revision 2602)
+++ trunk/kBuild/sdks/WINDDK71WLH.kmk	(revision 2602)
@@ -0,0 +1,47 @@
+# $Id$
+## @file
+# kBuild SDK - The Microsoft Windows 7 DDKs, v7.1, Targeting Vista and 2008 (KBUILD_TARGET_ARCH).
+#
+
+#
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+SDK_WINDDK71WLH := The Microsoft Windows 7 DDKs, v7.1, Targeting Vista and 2008 (KBUILD_TARGET_ARCH).
+SDK_WINDDK71WLH_EXTENDS = WINDDK71
+SDK_WINDDK71WLH_DEFS          ?= WIN32=100 _WIN32_WINNT=0x0600 WINVER=0x0600 _WIN32_IE=0x0700 NTDDI_VERSION=0x06000000 KMDF_MAJOR_VERSION=01 KMDF_MINOR_VERSION=005
+SDK_WINDDK71WLH_LIBPATH.amd64 ?= $(PATH_SDK_WINDDK71_LIB_WLH.amd64)
+SDK_WINDDK71WLH_LIBPATH.ia64  ?= $(PATH_SDK_WINDDK71_LIB_WLH.ia64)
+SDK_WINDDK71WLH_LIBPATH.x86   ?= $(PATH_SDK_WINDDK71_LIB_WLH.x86)
+
+# SDK Specific Properties.
+# Note! extends the WINDDK71 sdk, so use those variables where ever possible
+PATH_SDK_WINDDK71WLH_LIB.amd64?= $(PATH_SDK_WINDDK71_LIB_WLH.amd64)
+PATH_SDK_WINDDK71WLH_LIB.ia64 ?= $(PATH_SDK_WINDDK71_LIB_WLH.ia64)
+PATH_SDK_WINDDK71WLH_LIB.x86  ?= $(PATH_SDK_WINDDK71_LIB_WLH.x86)
+PATH_SDK_WINDDK71WLH_LIB      ?= $(PATH_SDK_WINDDK71WLH_LIB.$(KBUILD_TARGET_ARCH))
+
Index: trunk/kBuild/sdks/WINDDK71WNET.kmk
===================================================================
--- trunk/kBuild/sdks/WINDDK71WNET.kmk	(revision 2602)
+++ trunk/kBuild/sdks/WINDDK71WNET.kmk	(revision 2602)
@@ -0,0 +1,47 @@
+# $Id$
+## @file
+# kBuild SDK - The Microsoft Windows 7 DDKs, v7.1, Targeting Windows Server 2003 (KBUILD_TARGET_ARCH).
+#
+
+#
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+SDK_WINDDK71WNET := The Microsoft Windows 7 DDKs, v7.1, Targeting Windows Server 2003 (KBUILD_TARGET_ARCH).
+SDK_WINDDK71WNET_EXTENDS = WINDDK71
+SDK_WINDDK71WNET_DEFS          ?= WIN32=100 _WIN32_WINNT=0x0502 WINVER=0x0502 _WIN32_IE=0x0603 NTDDI_VERSION=0x05020100
+SDK_WINDDK71WNET_LIBPATH.amd64 ?= $(PATH_SDK_WINDDK71_LIB_WNET.amd64)
+SDK_WINDDK71WNET_LIBPATH.ia64  ?= $(PATH_SDK_WINDDK71_LIB_WNET.ia64)
+SDK_WINDDK71WNET_LIBPATH.x86   ?= $(PATH_SDK_WINDDK71_LIB_WNET.x86)
+
+# SDK Specific Properties.
+# Note! extends the WINDDK71 sdk, so use those variables where ever possible
+PATH_SDK_WINDDK71WNET_LIB.amd64?= $(PATH_SDK_WINDDK71_LIB_WNET.amd64)
+PATH_SDK_WINDDK71WNET_LIB.ia64 ?= $(PATH_SDK_WINDDK71_LIB_WNET.ia64)
+PATH_SDK_WINDDK71WNET_LIB.x86  ?= $(PATH_SDK_WINDDK71_LIB_WNET.x86)
+PATH_SDK_WINDDK71WNET_LIB      ?= $(PATH_SDK_WINDDK71WNET_LIB.$(KBUILD_TARGET_ARCH))
+
Index: trunk/kBuild/sdks/WINDDK71WXP.kmk
===================================================================
--- trunk/kBuild/sdks/WINDDK71WXP.kmk	(revision 2602)
+++ trunk/kBuild/sdks/WINDDK71WXP.kmk	(revision 2602)
@@ -0,0 +1,43 @@
+# $Id$
+## @file
+# kBuild SDK - The Microsoft Windows 7 DDK, v7.1, Targeting Windows XP (x86).
+#
+
+#
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+SDK_WINDDK71WXP := The Microsoft Windows 7 DDK, v7.1, Targeting Windows XP (x86).
+SDK_WINDDK71WXP_EXTENDS = WINDDK71
+SDK_WINDDK71WXP_DEFS          ?= WIN32=100 _WIN32_WINNT=0x0501 WINVER=0x0501 _WIN32_IE=0x0603 NTDDI_VERSION=0x05010200
+SDK_WINDDK71WXP_LIBPATH.x86   ?= $(PATH_SDK_WINDDK71_LIB_WXP.x86)
+
+# SDK Specific Properties.
+# Note! extends the WINDDK71 sdk, so use those variables where ever possible
+PATH_SDK_WINDDK71WXP_LIB.x86  ?= $(PATH_SDK_WINDDK71_LIB_WXP.x86)
+PATH_SDK_WINDDK71WXP_LIB      ?= $(PATH_SDK_WINDDK71WXP_LIB.x86)
+
Index: trunk/kBuild/sdks/WINPSDK.kmk
===================================================================
--- trunk/kBuild/sdks/WINPSDK.kmk	(revision 2578)
+++ trunk/kBuild/sdks/WINPSDK.kmk	(revision 2602)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (c) 2006-2010 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
 #
 # This file is part of kBuild.
@@ -42,7 +42,4 @@
  ifeq ($(PATH_SDK_WINPSDK),)
   PATH_SDK_WINPSDK := $(wildcard $(PATH_DEVTOOLS)/win.x86/sdk/2*)
- endif
- ifeq ($(PATH_SDK_WINPSDK),)
-  PATH_SDK_WINPSDK := $(wildcard $(PATH_DEVTOOLS)/x86.win32/sdk/2*)
  endif
  ifeq ($(PATH_SDK_WINPSDK),)
Index: trunk/kBuild/sdks/WINPSDK71.kmk
===================================================================
--- trunk/kBuild/sdks/WINPSDK71.kmk	(revision 2602)
+++ trunk/kBuild/sdks/WINPSDK71.kmk	(revision 2602)
@@ -0,0 +1,161 @@
+# $Id$
+## @file
+# kBuild SDK - The Windows Platform SDK v7.1, targeting (KBUILD_TARGET).
+#
+
+#
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+SDK_WINPSDK71 := The Windows Platform SDK v7.1, targeting (KBUILD_TARGET).
+
+# SDK Specific Properties
+ifndef PATH_SDK_WINPSDK71
+ PATH_SDK_WINPSDK71 := $(wildcard $(PATH_DEVTOOLS_BLD)/sdk/v7.1*)
+ ifeq ($(PATH_SDK_WINPSDK71),)
+  PATH_SDK_WINPSDK71 := $(wildcard $(PATH_DEVTOOLS_TRG)/sdk/v7.1*)
+ endif
+ ifeq ($(PATH_SDK_WINPSDK71),)
+  PATH_SDK_WINPSDK71 := $(wildcard $(PATH_DEVTOOLS)/win.x86/sdk/v7.1*)
+ endif
+ ifeq ($(PATH_SDK_WINPSDK71),)
+  PATH_SDK_WINPSDK71 := $(wildcard $(PATH_DEVTOOLS)/win.amd64/sdk/v7.1*)
+ endif
+ ifneq ($(PATH_SDK_WINPSDK71),)
+  PATH_SDK_WINPSDK71 := $(lastword $(sort $(PATH_SDK_WINPSDK71)))
+ else
+  $(warning kBuild: PATH_SDK_WINPSDK71 couldn't be determined!)
+  PATH_SDK_WINPSDK71 := $(PATH_DEVTOOLS_BLD)/sdk/v7.1-not-found
+ endif
+else
+ PATH_SDK_WINPSDK71 := $(PATH_SDK_WINPSDK71)
+endif
+
+ifndef PATH_SDK_WINPSDK71_INC
+PATH_SDK_WINPSDK71_INC := $(firstword $(wildcard $(PATH_SDK_WINPSDK71)/[Ii][Nn][Cc][Ll][Uu][Dd][Ee]) $(PATH_SDK_WINPSDK71)/Include)
+endif
+
+ifndef PATH_SDK_WINPSDK71_LIB.x86
+PATH_SDK_WINPSDK71_LIB.x86 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71)/[Ll][Ii][Bb]) $(PATH_SDK_WINPSDK71)/Lib)
+endif
+ifndef PATH_SDK_WINPSDK71_LIB.amd64
+PATH_SDK_WINPSDK71_LIB.amd64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71)/[Ll][Ii][Bb]/[Aa][Mm][Dd]64 $(PATH_SDK_WINPSDK71)/[Ll][Ii][Bb]/[xX]64) $(PATH_SDK_WINPSDK71)/Lib/AMD64)
+endif
+ifndef PATH_SDK_WINPSDK71_LIB.ia64
+PATH_SDK_WINPSDK71_LIB.ia64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71)/[Ll][Ii][Bb]/[Ii][Aa]64) $(PATH_SDK_WINPSDK71)/Lib/IA64)
+endif
+PATH_SDK_WINPSDK71_LIB ?= $(PATH_SDK_WINPSDK71_LIB.$(KBUILD_TARGET_ARCH))
+
+ifndef PATH_SDK_WINPSDK71_BIN
+PATH_SDK_WINPSDK71_BIN := $(firstword $(wildcard $(PATH_SDK_WINPSDK71)/[Bb][Ii][Nn]) $(PATH_SDK_WINPSDK71)/Bin)
+endif
+ifndef PATH_SDK_WINPSDK71_BIN_AMD64
+PATH_SDK_WINPSDK71_BIN_AMD64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71_BIN)/[Ww][Ii][Nn]64/[Xx]86/[Aa][Mm][Dd]64 $(PATH_SDK_WINPSDK71_BIN)/[Ww][Ii][Nn]64/[Xx]86) $(PATH_SDK_WINPSDK71_BIN)/win64/AMD64)
+endif
+ifndef PATH_SDK_WINPSDK71_BIN_IA64
+PATH_SDK_WINPSDK71_BIN_IA64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71_BIN)/[Ww][Ii][Nn]64) $(PATH_SDK_WINPSDK71_BIN)/win64)
+endif
+
+
+# General Properties used by kBuild
+SDK_WINPSDK71_INCS ?= $(PATH_SDK_WINPSDK71_INC)
+SDK_WINPSDK71_LIBPATH.x86   ?= $(PATH_SDK_WINPSDK71_LIB.x86)
+SDK_WINPSDK71_LIBPATH.amd64 ?= $(PATH_SDK_WINPSDK71_LIB.amd64)
+SDK_WINPSDK71_LIBPATH.ia64  ?= $(PATH_SDK_WINPSDK71_LIB.ia64)
+SDK_WINPSDK71_LIBS.x86 ?= \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/Kernel32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/User32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/Gdi32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/AdvAPI32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/Shell32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/ShLwApi.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/SetupAPI.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/Uuid.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/Version.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/WS2_32.Lib \
+	\
+	$(PATH_SDK_WINPSDK71_LIB.x86)/Ole32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/OleAut32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/OleDlg.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/RpcRT4.Lib \
+	\
+	$(PATH_SDK_WINPSDK71_LIB.x86)/DbgHelp.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/ImageHlp.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/IPHlpApi.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/ComCtl32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/ComDlg32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/WinSpool.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.x86)/WinMM.Lib
+SDK_WINPSDK71_LIBS.amd64 ?= \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/Kernel32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/User32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/Gdi32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/AdvAPI32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/Shell32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/ShLwApi.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/SetupAPI.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/Uuid.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/Version.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/WS2_32.Lib \
+	\
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/Ole32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/OleAut32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/OleDlg.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/RpcRT4.Lib \
+	\
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/DbgHelp.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/ImageHlp.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/IPHlpApi.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/ComCtl32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/ComDlg32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/WinSpool.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.amd64)/WinMM.Lib
+SDK_WINPSDK71_LIBS.ia64 ?= \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/Kernel32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/User32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/Gdi32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/AdvAPI32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/Shell32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/ShLwApi.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/SetupAPI.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/Uuid.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/Version.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/WS2_32.Lib \
+	\
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/Ole32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/OleAut32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/OleDlg.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/RpcRT4.Lib \
+	\
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/DbgHelp.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/ImageHlp.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/IPHlpApi.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/ComCtl32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/ComDlg32.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/WinSpool.Lib \
+	$(PATH_SDK_WINPSDK71_LIB.ia64)/WinMM.Lib
+
Index: trunk/kBuild/sdks/WINPSDK71INCS.kmk
===================================================================
--- trunk/kBuild/sdks/WINPSDK71INCS.kmk	(revision 2602)
+++ trunk/kBuild/sdks/WINPSDK71INCS.kmk	(revision 2602)
@@ -0,0 +1,90 @@
+# $Id$
+## @file
+# kBuild SDK - The Windows Platform SDK v7.1, targeting (KBUILD_TARGET) but
+#              without any libraries or LIBPATH properties.
+#              Basically for finding specstrings.h when using the DDK.
+#
+
+#
+# Copyright (c) 2006-2012 knut st. osmundsen <bird-kBuild-spamx@anduin.net>
+#
+# This file is part of kBuild.
+#
+# kBuild is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kBuild is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kBuild; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+# As a special exception you are granted permission to include this file, via
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
+# This exception does not however invalidate any other reasons why the makefile,
+# program, whatever should not be covered the GPL.
+#
+#
+
+SDK_WINPSDK71INCS := The Windows Platform SDK v7.1, targeting (KBUILD_TARGET) but \
+	without any library or LIBPATH properties. \
+	Basically for finding specstrings.h when using the DDK.
+
+# SDK Specific Properties
+ifndef PATH_SDK_WINPSDK71INCS
+ ifdef PATH_SDK_WINPSDK71
+  PATH_SDK_WINPSDK71INCS := $(PATH_SDK_WINPSDK71)
+ else
+  PATH_SDK_WINPSDK71INCS := $(wildcard $(PATH_DEVTOOLS_BLD)/sdk/v7.1*)
+  ifeq ($(PATH_SDK_WINPSDK71INCS),)
+   PATH_SDK_WINPSDK71INCS := $(wildcard $(PATH_DEVTOOLS_TRG)/sdk/v7.1*)
+  endif
+  ifeq ($(PATH_SDK_WINPSDK71INCS),)
+   PATH_SDK_WINPSDK71INCS := $(wildcard $(PATH_DEVTOOLS)/win.x86/sdk/v7.1*)
+  endif
+  ifeq ($(PATH_SDK_WINPSDK71INCS),)
+   PATH_SDK_WINPSDK71INCS := $(wildcard $(PATH_DEVTOOLS)/win.amd64/sdk/v7.1*)
+  endif
+  ifneq ($(PATH_SDK_WINPSDK71INCS),)
+   PATH_SDK_WINPSDK71INCS := $(lastword $(sort $(PATH_SDK_WINPSDK71INCS)))
+  else
+   $(warning kBuild: PATH_SDK_WINPSDK71INCS couldn't be determined!)
+   PATH_SDK_WINPSDK71INCS := $(PATH_DEVTOOLS_BLD)/sdk/v7.1-not-found
+  endif
+ endif
+else
+ PATH_SDK_WINPSDK71INCS := $(PATH_SDK_WINPSDK71INCS)
+endif
+ifndef PATH_SDK_WINPSDK71INCS_INC
+PATH_SDK_WINPSDK71INCS_INC := $(firstword $(wildcard $(PATH_SDK_WINPSDK71INCS)/[Ii][Nn][Cc][Ll][Uu][Dd][Ee]) $(PATH_SDK_WINPSDK71INCS)/Include)
+endif
+
+ifndef PATH_SDK_WINPSDK71INCS_LIB.x86
+PATH_SDK_WINPSDK71INCS_LIB.x86 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71INCS)/[Ll][Ii][Bb]) $(PATH_SDK_WINPSDK71INCS)/Lib)
+endif
+ifndef PATH_SDK_WINPSDK71INCS_LIB.amd64
+PATH_SDK_WINPSDK71INCS_LIB.amd64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71INCS)/[Ll][Ii][Bb]/[Aa][Mm][Dd]64) $(PATH_SDK_WINPSDK71INCS)/Lib/AMD64)
+endif
+PATH_SDK_WINPSDK71INCS_LIB ?= $(PATH_SDK_WINPSDK71INCS_LIB.$(KBUILD_TARGET_ARCH))
+
+ifndef PATH_SDK_WINPSDK71INCS_BIN
+PATH_SDK_WINPSDK71INCS_BIN := $(firstword $(wildcard $(PATH_SDK_WINPSDK71INCS)/[Bb][Ii][Nn]) $(PATH_SDK_WINPSDK71INCS)/Bin)
+endif
+ifndef PATH_SDK_WINPSDK71INCS_BIN_AMD64
+PATH_SDK_WINPSDK71INCS_BIN_AMD64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71INCS_BIN)/[Ww][Ii][Nn]64/[Xx]86/[Aa][Mm][Dd]64) $(PATH_SDK_WINPSDK71INCS_BIN)/win64/AMD64)
+endif
+ifndef PATH_SDK_WINPSDK71INCS_BIN_IA64
+PATH_SDK_WINPSDK71INCS_BIN_IA64 := $(firstword $(wildcard $(PATH_SDK_WINPSDK71INCS_BIN)/[Ww][Ii][Nn]64) $(PATH_SDK_WINPSDK71INCS_BIN)/win64)
+endif
+
+
+# General Properties used by kBuild
+SDK_WINPSDK71INCS_INCS ?= $(PATH_SDK_WINPSDK71INCS_INC)
+