Index: trunk/src/kernel32/KERNEL32.DEF
===================================================================
--- trunk/src/kernel32/KERNEL32.DEF	(revision 2612)
+++ trunk/src/kernel32/KERNEL32.DEF	(revision 2613)
@@ -1,3 +1,3 @@
-; $Id: KERNEL32.DEF,v 1.67 2000-01-29 10:42:37 sandervl Exp $
+; $Id: KERNEL32.DEF,v 1.68 2000-02-03 18:56:38 sandervl Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -1073,6 +1073,10 @@
     IsExeStarted__Fv     @2001
     CheckCurFS           @2002
+    SupportsCPUID        @2003
+    GetCPUFeatures       @2004
+    CPUFeatures          @2005
 
     GetDisplayCodepage__Fv                  @3000
     GetWindowsCodepage__Fv                  @3001
-
+    
+
Index: trunk/src/kernel32/cpu.cpp
===================================================================
--- trunk/src/kernel32/cpu.cpp	(revision 2612)
+++ trunk/src/kernel32/cpu.cpp	(revision 2613)
@@ -1,3 +1,3 @@
-/* $Id: cpu.cpp,v 1.4 1999-12-09 11:59:27 sandervl Exp $ */
+/* $Id: cpu.cpp,v 1.5 2000-02-03 18:56:39 sandervl Exp $ */
 /*
  * Odin win32 CPU apis
@@ -20,5 +20,5 @@
 #include "winreg.h"
 #include "debugtools.h"
-#include "cpuhlp.h"
+#include <cpuhlp.h>
 #include "initsystem.h"
 
Index: trunk/src/kernel32/cpuhlp.asm
===================================================================
--- trunk/src/kernel32/cpuhlp.asm	(revision 2612)
+++ trunk/src/kernel32/cpuhlp.asm	(revision 2613)
@@ -1,3 +1,3 @@
-; $Id: cpuhlp.asm,v 1.1 1999-11-23 19:31:35 sandervl Exp $
+; $Id: cpuhlp.asm,v 1.2 2000-02-03 18:56:39 sandervl Exp $
 
 ;/*
@@ -9,5 +9,13 @@
 ; */
 .586
-                NAME    except
+                NAME    cpuhlp
+
+DATA32  SEGMENT DWORD PUBLIC USE32 'DATA'
+        ASSUME  DS:FLAT,SS:FLAT
+
+	PUBLIC  CPUFeatures
+CPUFeatures     dd 0
+
+DATA32  ENDS
 
 CODE32          SEGMENT DWORD PUBLIC USE32 'CODE'
@@ -77,4 +85,6 @@
 	mov	eax, edx	
 
+	mov	[CPUFeatures], eax
+
 	pop	edx
 	pop	ecx
Index: trunk/src/kernel32/cpuhlp.h
===================================================================
--- trunk/src/kernel32/cpuhlp.h	(revision 2612)
+++ 	(revision )
@@ -1,39 +1,0 @@
-/* $Id: cpuhlp.h,v 1.2 1999-11-23 20:01:18 sandervl Exp $ */
-
-#ifndef _CPUHLP_H_
-#define _CPUHLP_H_
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#define BIT(a)	(1<<a)
-
-#define CPUID_FPU_PRESENT		BIT(0)
-#define CPUID_VMMODE_EXTENSIONS		BIT(1)
-#define CPUID_DBG_EXTENSIONS		BIT(2)
-#define CPUID_PAGE_SIZE_EXTENSIONS	BIT(3)
-#define CPUID_TIME_STAMP_COUNTER	BIT(4)
-#define CPUID_K86_MODEL_REGS		BIT(5)
-#define CPUID_MACHINE_CHECK_EXCEPTION	BIT(7)
-#define CPUID_CMPXCHG8B_INSTRUCTION	BIT(8)
-#define CPUID_APIC			BIT(9)
-#define CPUID_MEMORY_TYPE_RANGE_REGS	BIT(12)
-#define CPUID_GLOBAL_PAGING_EXTENSIONS	BIT(13)
-#define CPUID_CONDITIONAL_MOVE		BIT(15)
-#define CPUID_MMX			BIT(23)
-
-BOOL  SupportsCPUID();
-
-void  GetCPUVendorString(char *vendor);
-DWORD GetCPUFeatures();
-DWORD GetCPUSignature();
-
-void  InitSystemInfo(int nrcpus);
-
-#ifdef __cplusplus
-}
-#endif
-
-#endif /* _CPUHLP_H_ */
-
Index: trunk/src/kernel32/makefile
===================================================================
--- trunk/src/kernel32/makefile	(revision 2612)
+++ trunk/src/kernel32/makefile	(revision 2613)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.79 2000-01-03 21:36:10 sandervl Exp $
+# $Id: makefile,v 1.80 2000-02-03 18:56:39 sandervl Exp $
 
 #
@@ -162,5 +162,5 @@
 
 initterm.OBJ: .\initterm.cpp initterm.h  $(PDWIN32_INCLUDE)\heapshared.h  mmap.h directory.h hmdevio.h initsystem.h $(PDWIN32_INCLUDE)\heapcode.h
-initsystem.obj: initsystem.cpp cpuhlp.h initsystem.h $(PDWIN32_INCLUDE)\misc.h directory.h $(PDWIN32_INCLUDE)\versionos2.h
+initsystem.obj: initsystem.cpp $(PDWIN32_INCLUDE)\cpuhlp.h initsystem.h $(PDWIN32_INCLUDE)\misc.h directory.h $(PDWIN32_INCLUDE)\versionos2.h
 
 
@@ -407,5 +407,5 @@
 heapshared.obj: heapshared.cpp $(PDWIN32_INCLUDE)\heapshared.h
 heapcode.obj: heapcode.cpp $(PDWIN32_INCLUDE)\heapshared.h $(PDWIN32_INCLUDE)\heapcode.h
-cpu.obj: cpu.cpp cpuhlp.h
+cpu.obj: cpu.cpp $(PDWIN32_INCLUDE)\cpuhlp.h
 cpuhlp.obj: cpuhlp.asm
 environ.obj: environ.cpp $(PDWIN32_INCLUDE)\misc.h