Index: trunk/kBuild/tools/VCC100.kmk
===================================================================
--- trunk/kBuild/tools/VCC100.kmk	(revision 2611)
+++ trunk/kBuild/tools/VCC100.kmk	(revision 2621)
@@ -155,26 +155,25 @@
 TOOL_VCC100_COMPILE_C_DEPEND =
 TOOL_VCC100_COMPILE_C_DEPORD =
-TOOL_VCC100_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC100_PDB, $(outbase)-obj,pdb)
 ifdef KBUILD_USE_KOBJCACHE
 TOOL_VCC100_COMPILE_C_USES_KOBJCACHE = 1
-TOOL_VCC100_COMPILE_C_OUTPUT = $(call TOOL_VCC100_PDB, $(outbase)-obj,idb) $(outbase).i
+TOOL_VCC100_COMPILE_C_OUTPUT = $(outbase).i
+TOOL_VCC100_COMPILE_C_OUTPUT_MAYBE =
 define TOOL_VCC100_COMPILE_C_CMDS
-	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -r\
+	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -O2 -r\
+		--make-dep-fix-case --make-dep-gen-stubs --make-dep-quiet --make-dep-file $(dep)\
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_VCC100_CC) -E\
-		$(flags)\
+		$(subst -Zi,-Z7,$(flags))\
 		$(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
 		$(subst /,\\,$(abspath $(source))) \
 		--kObjCache-cc $(obj)\
-		$(TOOL_VCC100_C) -c\
-		$(flags)\
-		-Fd$(outbase)-obj.pdb \
-		-FD\
+		$(TOOL_VCC100_CC) -c\
+		$(subst -Zi,-Z7,$(flags))\
 		-Fo$(obj)\
 		$(outbase).i
-	$(QUIET)$(DEP_IDB) -f -s -q -o $(dep) -t $(obj) $(call TOOL_VCC100_PDB,$(outbase)-obj,idb)
 endef
 else  # !KBUILD_USE_KOBJCACHE
 TOOL_VCC100_COMPILE_C_OUTPUT = $(call TOOL_VCC100_PDB, $(outbase)-obj,idb)
+TOOL_VCC100_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC100_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC100_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC100_CC) -c\
@@ -204,26 +203,25 @@
 TOOL_VCC100_COMPILE_CXX_DEPEND =
 TOOL_VCC100_COMPILE_CXX_DEPORD =
-TOOL_VCC100_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC100_PDB, $(outbase)-obj,pdb)
 ifdef KBUILD_USE_KOBJCACHE
 TOOL_VCC100_COMPILE_CXX_USES_KOBJCACHE = 1
-TOOL_VCC100_COMPILE_CXX_OUTPUT = $(call TOOL_VCC100_PDB, $(outbase)-obj,idb) $(outbase).ii
+TOOL_VCC100_COMPILE_CXX_OUTPUT = $(outbase).ii
+TOOL_VCC100_COMPILE_CXX_OUTPUT_MAYBE =
 define TOOL_VCC100_COMPILE_CXX_CMDS
-	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -r\
+	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -O2 -r\
+		--make-dep-fix-case --make-dep-gen-stubs --make-dep-quiet --make-dep-file $(dep)\
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_VCC100_CXX) -E\
-		$(flags)\
+		$(subst -Zi,-Z7,$(flags))\
 		$(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
 		$(subst /,\\,$(abspath $(source))) \
 		--kObjCache-cc $(obj)\
 		$(TOOL_VCC100_CXX) -c\
-		$(flags)\
-		-Fd$(outbase)-obj.pdb \
-		-FD\
+		$(subst -Zi,-Z7,$(flags))\
 		-Fo$(obj)\
 		$(outbase).ii
-	$(QUIET)$(DEP_IDB) -f -s -q -o $(dep) -t $(obj) $(call TOOL_VCC100_PDB,$(outbase)-obj,idb)
 endef
 else  # !KBUILD_USE_KOBJCACHE
 TOOL_VCC100_COMPILE_CXX_OUTPUT = $(call TOOL_VCC100_PDB, $(outbase)-obj,idb)
+TOOL_VCC100_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC100_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC100_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC100_CXX) -c\
Index: trunk/kBuild/tools/VCC100AMD64.kmk
===================================================================
--- trunk/kBuild/tools/VCC100AMD64.kmk	(revision 2611)
+++ trunk/kBuild/tools/VCC100AMD64.kmk	(revision 2621)
@@ -136,26 +136,25 @@
 TOOL_VCC100AMD64_COMPILE_C_DEPEND =
 TOOL_VCC100AMD64_COMPILE_C_DEPORD =
-TOOL_VCC100AMD64_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,pdb)
 ifdef KBUILD_USE_KOBJCACHE
 TOOL_VCC100AMD64_COMPILE_C_USES_KOBJCACHE = 1
-TOOL_VCC100AMD64_COMPILE_C_OUTPUT = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,idb) $(outbase).i
+TOOL_VCC100AMD64_COMPILE_C_OUTPUT = $(outbase).i
+TOOL_VCC100AMD64_COMPILE_C_OUTPUT_MAYBE =
 define TOOL_VCC100AMD64_COMPILE_C_CMDS
-	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -r\
+	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -O2 -r\
+		--make-dep-fix-case --make-dep-gen-stubs --make-dep-quiet --make-dep-file $(dep)\
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_VCC100AMD64_CC) -E\
-		$(flags)\
+		$(subst -Zi,-Z7,$(flags))\
 		$(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
 		$(subst /,\\,$(abspath $(source))) \
 		--kObjCache-cc $(obj)\
 		$(TOOL_VCC100AMD64_CC) -c\
-		$(flags)\
-		-Fd$(outbase)-obj.pdb \
-		-FD\
+		$(subst -Zi,-Z7,$(flags))\
 		-Fo$(obj)\
 		$(outbase).i
-	$(QUIET)$(DEP_IDB) -f -s -q -o $(dep) -t $(obj) $(call TOOL_VCC100AMD64_PDB,$(outbase)-obj,idb)
 endef
 else  # !KBUILD_USE_KOBJCACHE
 TOOL_VCC100AMD64_COMPILE_C_OUTPUT = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC100AMD64_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC100AMD64_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC100AMD64_CC) -c\
@@ -185,26 +184,25 @@
 TOOL_VCC100AMD64_COMPILE_CXX_DEPEND =
 TOOL_VCC100AMD64_COMPILE_CXX_DEPORD =
-TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,pdb)
 ifdef KBUILD_USE_KOBJCACHE
 TOOL_VCC100AMD64_COMPILE_CXX_USES_KOBJCACHE = 1
-TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,idb) $(outbase).ii
+TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT = $(outbase).ii
+TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT_MAYBE =
 define TOOL_VCC100AMD64_COMPILE_CXX_CMDS
-	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -r\
+	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -O2 -r\
+		--make-dep-fix-case --make-dep-gen-stubs --make-dep-quiet --make-dep-file $(dep)\
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_VCC100AMD64_CXX) -E\
-		$(flags)\
+		$(subst -Zi,-Z7,$(flags))\
 		$(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
 		$(subst /,\\,$(abspath $(source))) \
 		--kObjCache-cc $(obj)\
 		$(TOOL_VCC100AMD64_CXX) -c\
-		$(flags)\
-		-Fd$(outbase)-obj.pdb \
-		-FD\
+		$(subst -Zi,-Z7,$(flags))\
 		-Fo$(obj)\
 		$(outbase).ii
-	$(QUIET)$(DEP_IDB) -f -s -q -o $(dep) -t $(obj) $(call TOOL_VCC100AMD64_PDB,$(outbase)-obj,idb)
 endef
 else  # !KBUILD_USE_KOBJCACHE
 TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC100AMD64_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC100AMD64_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC100AMD64_CXX) -c\
Index: trunk/kBuild/tools/VCC100X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC100X86.kmk	(revision 2611)
+++ trunk/kBuild/tools/VCC100X86.kmk	(revision 2621)
@@ -137,26 +137,25 @@
 TOOL_VCC100X86_COMPILE_C_DEPEND =
 TOOL_VCC100X86_COMPILE_C_DEPORD =
-TOOL_VCC100X86_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,pdb)
 ifdef KBUILD_USE_KOBJCACHE
 TOOL_VCC100X86_COMPILE_C_USES_KOBJCACHE = 1
-TOOL_VCC100X86_COMPILE_C_OUTPUT = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,idb) $(outbase).i
+TOOL_VCC100X86_COMPILE_C_OUTPUT = $(outbase).i
+TOOL_VCC100AMD64_COMPILE_C_OUTPUT_MAYBE =
 define TOOL_VCC100X86_COMPILE_C_CMDS
-	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -r\
+	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -O2 -r\
+		--make-dep-fix-case --make-dep-gen-stubs --make-dep-quiet --make-dep-file $(dep)\
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_VCC100X86_CC) -E\
-		$(flags)\
+		$(subst -Zi,-Z7,$(flags))\
 		$(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
 		$(subst /,\\,$(abspath $(source))) \
 		--kObjCache-cc $(obj)\
 		$(TOOL_VCC100X86_CC) -c\
-		$(flags)\
-		-Fd$(outbase)-obj.pdb \
-		-FD\
+		$(subst -Zi,-Z7,$(flags))\
 		-Fo$(obj)\
 		$(outbase).i
-	$(QUIET)$(DEP_IDB) -f -s -q -o $(dep) -t $(obj) $(call TOOL_VCC100X86_PDB,$(outbase)-obj,idb)
 endef
 else  # !KBUILD_USE_KOBJCACHE
 TOOL_VCC100X86_COMPILE_C_OUTPUT = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC100X86_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC100X86_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC100X86_CC) -c\
@@ -186,26 +185,25 @@
 TOOL_VCC100X86_COMPILE_CXX_DEPEND =
 TOOL_VCC100X86_COMPILE_CXX_DEPORD =
-TOOL_VCC100X86_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,pdb)
 ifdef KBUILD_USE_KOBJCACHE
 TOOL_VCC100X86_COMPILE_CXX_USES_KOBJCACHE = 1
-TOOL_VCC100X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,idb) $(outbase).ii
+TOOL_VCC100X86_COMPILE_CXX_OUTPUT = $(outbase).ii
+TOOL_VCC100AMD64_COMPILE_CXX_OUTPUT_MAYBE =
 define TOOL_VCC100X86_COMPILE_CXX_CMDS
-	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -r\
+	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -O2 -r\
+		--make-dep-fix-case --make-dep-gen-stubs --make-dep-quiet --make-dep-file $(dep)\
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_VCC100X86_CXX) -E\
-		$(flags)\
+		$(subst -Zi,-Z7,$(flags))\
 		$(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
 		$(subst /,\\,$(abspath $(source))) \
 		--kObjCache-cc $(obj)\
 		$(TOOL_VCC100X86_CXX) -c\
-		$(flags)\
-		-Fd$(outbase)-obj.pdb \
-		-FD\
+		$(subst -Zi,-Z7,$(flags))\
 		-Fo$(obj)\
 		$(outbase).ii
-	$(QUIET)$(DEP_IDB) -f -s -q -o $(dep) -t $(obj) $(call TOOL_VCC100X86_PDB,$(outbase)-obj,idb)
 endef
 else  # !KBUILD_USE_KOBJCACHE
 TOOL_VCC100X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC100X86_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC100X86_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC100X86_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC100X86_CXX) -c\